/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2000-2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *     "Apache Jetspeed" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache" or
 *    "Apache Jetspeed", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package org.apache.jetspeed.om.security.ldap;

import org.apache.jetspeed.services.JetspeedLDAP;
import org.apache.jetspeed.services.ldap.LDAPURL;
import java.util.Vector;
import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;
import java.util.Vector;
import org.apache.jetspeed.om.security.Permission;

/**
 *
 * @author <a href="mailto:ender@kilicoglu.nom.tr">Ender KILICOGLU</a>
 * @version $Id: LDAPPermission.java,v 1.1 2002/10/21 22:31:15 taylor Exp $ 
 * 
 */
public class LDAPPermission extends BaseLDAPObject implements Permission {
  private String Name;
  public LDAPPermission(String Name,boolean isNew) {
    if (isNew){
      this.Name = Name;
      myAttrs = new BasicAttributes();
      myAttrs.put("uid",Name);
      myAttrs.put("permissionname",Name);
      Attribute oc = new BasicAttribute("objectclass");
      oc.add("jetspeedpermission");
      myAttrs.put(oc);
      ldapurl = JetspeedLDAP.buildURL("uid="+Name+",ou=permissions,ou=jetspeed");
      isNew = true;
    }else{
      ldapurl =JetspeedLDAP.buildURL("uid="+Name+",ou=permissions,ou=jetspeed");
      myAttrs =  JetspeedLDAP.read(ldapurl);
      this.Name = getutil("permissionname");
    }
  }
   public LDAPPermission(LDAPURL ldapurl) {
    this.ldapurl = ldapurl;
    myAttrs =  JetspeedLDAP.read(ldapurl);
    this.Name = getutil("permissionname");
  }
  //UPDATE
   public boolean update(boolean create){
    if (JetspeedLDAP.exists(ldapurl)){
      JetspeedLDAP.deleteAttrs(ldapurl,rmAttrs);
      JetspeedLDAP.updateEntry(ldapurl,myAttrs);
    }else{
      if (create){
        JetspeedLDAP.addEntry(ldapurl,myAttrs);
      }else {
        return false;
      }
    }
    return true;
  }
}